package com.ruoyi.system.mapper;

import com.ruoyi.common.core.domain.entity.SysDept;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 部门管理 数据层
 * 
 * @author ruoyi
 */
public interface SysDeptMapper
{
    /**
     * 查询部门管理数据
     * 
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptList(SysDept dept);

    public List<SysDept> selectAllDeptList(String headId);



    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptListByManager(SysDept dept);


    /**
     * 根据机构号查询自身及所有父级部门数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptListByDept(SysDept dept);



    /**
     * 根据机构号查询自身及所有父级部门数据
     *
     * @param parentId 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectChildDeptList(Long parentId);

    /**
     * 查询是否为父子机构
     *
     * @param parent 父机构   child 子机构
     * @return 部门信息集合
     */
    public SysDept Parent2Child(@Param("parent")String parent, @Param("child")String child);

    /**
     * 根据角色ID查询部门树信息
     * 
     * @param roleId 角色ID
     * @param deptCheckStrictly 部门树选择项是否关联显示
     * @return 选中部门列表
     */
    public List<Long> selectDeptListByRoleId(@Param("roleId") Long roleId, @Param("deptCheckStrictly") boolean deptCheckStrictly);

    /**
     * 根据部门ID查询信息
     * 
     * @param deptId 部门ID
     * @return 部门信息
     */
    public SysDept selectDeptById(Long deptId);

    /**
     * 根据ID查询所有子部门
     * 
     * @param deptId 部门ID
     * @return 部门列表
     */
    public List<SysDept> selectChildrenDeptById(Long deptId);

    /**
     * 根据ID查询所有子部门（正常状态）
     * 
     * @param deptId 部门ID
     * @return 子部门数
     */
    public int selectNormalChildrenDeptById(Long deptId);

    /**
     * 是否存在子节点
     * 
     * @param deptId 部门ID
     * @return 结果
     */
    public int hasChildByDeptId(Long deptId);

    /**
     * 查询部门是否存在用户
     * 
     * @param deptId 部门ID
     * @return 结果
     */
    public int checkDeptExistUser(Long deptId);

    /**
     * 校验部门名称是否唯一
     * 
     * @param deptName 部门名称
     * @param parentId 父部门ID
     * @return 结果
     */
    public SysDept checkDeptNameUnique(@Param("deptName") String deptName, @Param("parentId") Long parentId);

    /**
     * 新增部门信息
     * 
     * @param dept 部门信息
     * @return 结果
     */
    public int insertDept(SysDept dept);

    /**
     * 修改部门信息
     * 
     * @param dept 部门信息
     * @return 结果
     */
    public int updateDept(SysDept dept);

    /**
     * 修改所在部门正常状态
     * 
     * @param deptIds 部门ID组
     */
    public void updateDeptStatusNormal(Long[] deptIds);

    /**
     * 修改子元素关系
     * 
     * @param depts 子元素
     * @return 结果
     */
    public int updateDeptChildren(@Param("depts") List<SysDept> depts);

    /**
     * 删除部门管理信息
     * 
     * @param deptId 部门ID
     * @return 结果
     */
    public int deleteDeptById(Long deptId);

    /**
     * 确认部门id是否已使用
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    public SysDept checkDeptIdExist(Long deptId);

    /**
     * 根据部门ID查询机构名称
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    public String selectDeptNameById(Long deptId);

    /**
     * 根据部门ID获取支行数量
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    public Long getDeptBranchById(Long deptId);

    /**
     * 根据部门ID获取网点数量
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    public Long getDeptOutletById(Long deptId);

    /**
     * 根据ID查询所有子部门
     *
     * @param headDeptId 部门ID
     * @return 部门列表
     */
    public List<SysDept> getBelongDeptInfo(String headDeptId);

    /**
     * 管护列表根据客户号获取其所有网点
     *
     * @param custId 部门ID
     * @return 部门信息
     */
    public String selectOutletNameById(@Param("custId")String custId ,@Param("deptId")String deptId);

    public String deptLevelId(@Param("userName") String  userName,@Param("level") String level);

    List<SysDept> selectHeadDeptList();

    List<Long> selectChildrenByDeptId(@Param("deptId") Long deptId);

}
